"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
require("./types/express");
var url_1 = __importDefault(require("url"));
var parsers_1 = __importDefault(require("./parsers"));
var _options = null;
function parseRequest(req) {
    var _a, _b, _c, _d;
    var skipIP = (_a = _options === null || _options === void 0 ? void 0 : _options.skipIP) !== null && _a !== void 0 ? _a : false;
    var parsedUrl = url_1.default.parse(req.protocol + "://" + ((_b = req.get('host')) !== null && _b !== void 0 ? _b : '') + req.originalUrl, true);
    var refUrl = url_1.default.parse((_c = req.header('referrer')) !== null && _c !== void 0 ? _c : '', true);
    var uaString = ((_d = req.header('user-agent')) !== null && _d !== void 0 ? _d : '').trim();
    var referrer = parsers_1.default.Referrer.parse(refUrl, _options);
    var utm = parsers_1.default.UTM.parse(refUrl.query);
    var ip = skipIP ? null : parsers_1.default.IP.parse(req);
    var ua = (uaString === '') ? null : parsers_1.default.UserAgent.parse(uaString);
    return {
        ip: ip,
        referrer: referrer,
        referrerUrl: refUrl,
        ua: ua,
        url: parsedUrl,
        utm: utm
    };
}
function init() {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, parsers_1.default.Referrer.init(_options)];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    });
}
function build(options) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _options = options !== null && options !== void 0 ? options : null;
                    return [4 /*yield*/, init()];
                case 1:
                    _a.sent();
                    return [2 /*return*/, function (req, _, next) {
                            try {
                                var result = parseRequest(req);
                                req.meta = result;
                                next();
                            }
                            catch (err) {
                                req.meta = null;
                                next();
                            }
                        }];
            }
        });
    });
}
exports.default = build;
function later(callback, options) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _options = options !== null && options !== void 0 ? options : null;
                    return [4 /*yield*/, init()];
                case 1:
                    _a.sent();
                    return [2 /*return*/, function (req, _, next) {
                            next();
                            try {
                                callback(parseRequest(req));
                                // eslint-disable-next-line no-empty
                            }
                            catch (_a) { }
                        }];
            }
        });
    });
}
exports.later = later;
